# -----------------------------------------------------------------------------
# (C) Bibix
# The content below includes confidential, proprietary information of
# Bibix. All use, disclosure, and/or reproduction is prohibited
# unless authorized in writing. All rights reserved.
# -----------------------------------------------------------------------------
# File         : time-curves.plt
# Description  : gnuplot script for plotting time-domain curves in # GFSK
#                simulations
# Author       : Sabih Gerez, Bibix
#                based on work by Rene Moll (DSE)
# Creation date: December 16, 2011
# -----------------------------------------------------------------------------
# $Rev: 287 $
# $Author: sabih $
# $Date: 2012-04-10 00:29:19 +0200 (Tue, 10 Apr 2012) $
# $Log$
# -----------------------------------------------------------------------------

set xrange [] noreverse nowriteback
#set xtics 200000
set xtics 5
#set mxtics 2
#set format x "%3.2e"

set yrange [] noreverse nowriteback
#set ytics 10
#set mytics 2
#set format y "%1.0e"
# set format y "10^{%L}"

set grid

#set terminal postscript
# enhanced = render superscripts, etc.
# set terminal jpeg 
# set output "ber-ideal.jpg"
# set output
# enhanced = render superscripts, etc.
set termoption enhanced

set style line 1 linewidth 1 linecolor rgbcolor "red"
set style line 2 linewidth 1 linecolor rgbcolor "blue"

set term x11 0
set yrange [-2:2] noreverse nowriteback
plot "../output_itpp/mixer_i.out" title "mixer_i (it++)" with linespoints, \
     "../output_itpp/mixer_q.out" title "mixer_q (it++)" with linespoints, \
     "../output_itpp/lpf_i.out" title "lpf_i (it++)" with linespoints

set term x11 1
set yrange [-1.2:1.2] noreverse nowriteback
plot "../output_itpp/dam.out" title "dam (it++)" with linespoints ls 1, \
     "../output_itpp/slc.out" title "slicer (it++)" with linespoints ls 2

set term x11 2
set yrange [-2:2] noreverse nowriteback
plot "../output_demod/mixer_i.out" title "mixer_i (Arx)" with linespoints, \
     "../output_demod/mixer_q.out" title "mixer_q (Arx)" with linespoints, \
     "../output_demod/lpf_i.out" title "lpf_i (Arx)" with linespoints

set term x11 3
set yrange [-1.2:1.2] noreverse nowriteback
plot "../output_demod/dam.out" title "dam (Arx)" with linespoints ls 1, \
     "../output_demod/slc.out" title "slicer (it++)" with linespoints ls 2

set term x11 4
set yrange [-1.2:1.2] noreverse nowriteback
plot "../output_slicer/dam.out" title "dam (Arx)" with linespoints ls 1, \
     "../output_slicer/slc.out" title "slicer (Arx)" with linespoints ls 2
